'use strict'
var extend = require('extend')
var iUtil = require('./util')
var doc = require('./doc')
var fs = require('fs')
/*
$.page({
    url: '/login/',
    template: 'view/login.html',
    data: {
        some:
    },
    render: function (req, res) {
        // req.cookies._也可以是 GET参数中的 _
        switch (req.cookies._) {
            case '1':
            break
            case '2':
            break
        }
    }
})
*/
module.exports = function (settings) {
    var $ = require('../index')
    settings = extend(true, {} ,$.config.pageSettings ,settings)

    settings.url = iUtil.checkUrl(settings.url)
    // url 错误时会返回 false
    if (!settings.url){
        return false
    }
    $.handle(settings.url, 'page', 'all', function (req, res) {
        var tpl = fs.readFileSync($._cwd + '/' + settings.template, 'utf-8');
        $.config.page.req(settings, req)
        settings.render(settings, req)
        $.config.page.globalRender(settings, req)
        var html = $.Handlebars.compile(tpl)(settings.data)
        res.send(html)
    })
    doc._data.push({
        type: 'page',
        settings: settings
    })
    $._data.pages.push({
        title: settings.title || settings.url,
        url: settings.url,
        filename: settings.url
    })
}