'use strict'
var $ = require('../index')
var controller = require('./controller')
var handlers = controller.handlers
var qs = require('querystring')
module.exports = function (req, res, next) {
    // 密码验证
    if ($.config.password && req.ip !== '127.0.0.1') {
        if (req.cookies.password != $.config.password) {
            handlers._password(req, res)
            return
        }
    }    

    // rewrite rule
    var pathname = req.path
    if (pathname !== '/nodeajax/') {
        $.config.urlRewrite.forEach(function (rule) {
            var searchValue = rule[0],
            replaceValue = rule[1]
            if (typeof searchValue === 'string') {
                // "/_console/" = "\/_console\/"
                searchValue = searchValue.replace(/([.$^{[(|)*+?\/\\])/g,'\\$1')
                searchValue = new RegExp('^' + searchValue + '$')
            }
            pathname = pathname.replace(searchValue, replaceValue)
        })
    }
    
    // 处理器
    var handler = handlers[pathname]
    var handlerType = ''
    // 存在处理器
    if (typeof handler === "object") {
        // 自定义处理器
        if (typeof handler.default === 'function') {
            handler.default(req, res)
        }
        // $.ajax 和 $.page
        else {
            if (req.xhr) {
                handlerType = 'ajax'
            }
            else {
                // 当没有 $.page 存在时使用 $.ajax 的 function
                if (typeof handler['page'] === 'function') {
                    handlerType = 'page'
                }
                else {
                    handlerType = 'ajax'
                }
            }
            if (handler[handlerType]) {
                if (handlerType === 'ajax') {
                    if (handler[handlerType][req.method]) {
                        // handler.ajax.get(req, res)
                        handler[handlerType][req.method](req, res)
                    }
                    else {
                        next()
                    }
                }
                else {
                    // handler.page(req, res)
                    handler[handlerType](req, res)
                }
            }
            else {
                next()
            }
        }
    }
    else {
        // 静态资源
        req.url = pathname + '?' + qs.stringify(req.query)
        handlers['_static']['default'](req, res)
    }
}